<?php
require_once("switch/logging.php");
require_once("switch/logconfig.php");
require_once("switch/raslog.php");
/**
 * starts_with
 * Tests if str text starts with an given stringi key.
 *
 * @param     string
 * @param     string
 * @return    bool
 */
function starts_with($str, $key){
    return strpos($str, $key) === 0;
}

function make_array($ss)
{
        if (!empty($ss)&& (!is_array($ss) || !isset($ss[0]))) {
                $ss_sav[0] = $ss;
        } else {
                $ss_sav = $ss;
        }
        return $ss_sav;
}

function Red($vc, $string)
{
        if (!isset($vc)) return;
        if ($vc->getDebug() != 0) {
                print "<br>";
                print "<font color=\"#FF0000\">";
                print $string . "@" . date("h:i:s");
                print "</font>";
                print "</br>";
        }
}
function Green($vc, $string)
{
        if (!isset($vc)) return;
        if ($vc->getDebug() != 0) {
                print "<br>";
                print "<font color=\"#006600\">";
                print $string . "@" . date("h:i:s") . " : Response";
                print "</font>";
                print "</br>";
        }
}
function vcDebug($vc, $obj)
{
        if (!isset($vc)) return;
        if ($vc->getDebug() != 0) {
                print "<textarea cols=100 rows=20>";
                print_r ($obj);
                print "</textarea>";
        }
}
function Debug($vc, $obj)
{
        print "<textarea cols=100 rows=20>";
        print_r ($obj);
        print "</textarea>";
}
function formatMac6_2_Mac3($mac)
{
        $m = array();
        $m = split(":", $mac);
        $mout = $m[0].$m[1] . "." . $m[2].$m[3] . "." . $m[4].$m[5];
        return $mout;
}
function getVcsMode()
{
        $hndl = popen("/fabos/libexec/DcmClient.Linux.powerpc dcmdebug getclustertype", "r");
        $read = fread($hndl, 100);
        pclose($hndl);
        return trim($read);
}
function getVcsId()
{
        $hndl = popen("/fabos/libexec/DcmClient.Linux.powerpc dcmdebug getvcsid", "r");
        $read = fread($hndl, 100);
        pclose($hndl);
        return trim($read);
}
function getRbridgeId()
{
        $hndl = popen("/fabos/libexec/DcmClient.Linux.powerpc dcmdebug getrbridgeid", "r");
        $read = fread($hndl, 100);
        pclose($hndl);
        return trim($read);
}

function publishVCenterEvents($input,$serverport)
{
raslogv(RASLOG_INFO, "publishVCenterEvents calling DcmClient");
        $hndl = popen("/fabos/libexec/DcmClient.Linux.powerpc -serverport $serverport dcmdebug sendvCenterEvents $input", "r");
        $read = fread($hndl, 100);
        pclose($hndl);
        return trim($read);
}
function trimSpaces($str)
{
        $str = urlencode($str);
        $pattern = array('/ /', '/\%/', '/\//', '/\\\/');
        $replacement = '@';
        //print("\n trimSpace ");
        //echo preg_replace($pattern, $replacement, $str);
        return preg_replace($pattern, $replacement, $str);
}
class StopWatch {
        var $time_start;
        var $time_end;
        function StopWatch()
        {
                $this->start(); 
                return $this;
        }

        function start()
        {
                // must use microtime for ms but doesnt work on our switch
                //$time_start = microtime(true);
                unset($this->time_start); 
                $this->time_start = time();
        }

        function stop()
        {
                // must use microtime for ms but doesnt work on our switch
                //$time_end = microtime(true);
                unset($this->time_end); 
                $this->time_end = time();
        }

        function resetAndStart()
        {
                $this->reset(); 
                $this->start(); 
        }
        function reset()
        {
                unset($this->time_start); 
                unset($this->time_end); 
        }

        function elapsedTime()
        {
                $this->stop(); 
                $time = $this->time_end - $this->time_start;
                return $time;
        }
}

function getPgByName($dbh, $name)
{
       $name  = sqlite_escape_string($name);
       $dvpg    = $dbh->getTableObjs("dvportgroups", "name='$name'");
       if(empty($dvpg))
           $dvpg = $dbh->getTableObjs("portgroups", "name='$name'");
        return $dvpg;
}
function getPgById($dbh, $pgId)
{
       $dvpg    = $dbh->getTableObjs("dvportgroups", "id='$pgId'");
       if(empty($dvpg))
           $dvpg = $dbh->getTableObjs("portgroups", "id='$pgId'");
        return $dvpg;
}
?>

