<?php

include_once("VC/utils.php");
include_once("VC/vCenter.php");
/*
EVENTS support
*/


function startEventsX($vc,$eventList)
{
        $sc = $vc->sc;

        $view_sess = CreateCollectorForEvents($vc, 'Folder', $sc->geteventManager(), $motype,$eventList);

        $et1[] = new soapval('type', '', 'EventHistoryCollector');
        $et1[] = new soapval('all', '', 'false');
        $et1[] = new soapval('pathSet', '', 'latestPage');
        $ps[] = new soapval('propSet', '', $et1);   
             
        $et2[] = new soapval('obj', 'EventHistoryCollector', $view_sess);
        $et2[] = new soapval('skip', '', 'false');
        $os[] = new soapval('objectSet', '', $et2);   

 
        $vmfilter = new Filter($vc, $sc->getPropertyCollector(), $ps, $os, true);
            $version="";
        while(1) {
        print("Waiting for updates... $version ");
        //raslogv(VCLOG_INFO, "Waiting for updates... $version ");
            $wfu     = WaitForUpdatesX($vc, $version);
        print_r($wfu);
        //raslogv(VCLOG_INFO, $wfu);
            if (empty($wfu)) {
                print("Waitforupdates timeout....");
                //raslogv(VCLOG_INFO, "Waitforupdates timeout....");
                Thread.sleep(10);
                continue;   
            }else{
                $version = $wfu['version'];
                processEvents($wfu);
            }
        }
        return $mors;
}

function stopEvents($vc)
{
    echo "Stopping Events ....";
    $sc = $vc->sc;
    $wfu     = CancelWaitForUpdates($vc);
}

function CreateCollectorForEvents($vc, $container, $view, $type, $eventList)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        $soapmsg[] = new soapval('_this', 'EventManager', $view, false, false, $vc->attrServerGuid);
        
        $et1[] = new soapval('entity', 'Folder', 'group-d1');
        $et1[] = new soapval('recursion', '', 'children');
        
        $entity[] = new soapval('entity', '', $et1);   

        foreach ($eventList as $event) {
            $entity[] = new soapval('type', '', $event);
        }
             
        $soapmsg[] = new soapval('filter', '', $entity);
        Red($vc, "CreateCollectorForEvents");
        $session = $conn->call("CreateCollectorForEvents", $soapmsg, $ns);
        Green($vc, $session);
        return $session;
}

/**********************/
/* LETS GET THE Hosts */
/**********************/

function getDC($vc, $mor_type, $mor)
{
        unset($vms);
        $sc = $vc->sc;
        $ps = new PropertySet($vc, array(
                                      array(type => '$mor_type', "name")
                                      )
                );
        $os = new ObjectSet($vc, array(
                                    array(type => '$mor_type', value => $mor)
                                    )
                );
        $vmfilter = new Filter($vc, $sc->getPropertyCollector(), $ps->propSet, $os->objectSet, true);
        $wfu     = WaitForUpdates($vc);
        $version = $wfu['version'];
        $filter  = $wfu['filterSet']['filter'];
        if ($filter == $vmfilter->filterID) {
                $objset    = $wfu['filterSet']['objectSet'];
                $changeset = $objset['changeSet'];
                $mo = $changeset['val']['ManagedObjectReference'];
                if (is_array($mo)) {
                        for ($i = 0 ; $i < count($mo); $i++) {
                                //echo "<br>VMx = $mo[$i]";
                                $vms[] = $mo[$i];
                        }
                } else {
                        //echo "<br>VMx = $mo";
                        $vms[] = $mo;
                }
        }
        return $vms;
}
function getMORS($vc, $motype)
{
        unset($mors);
        $sc = $vc->sc;
        $view_sess = createContainerView($vc, 'Folder', $sc->getViewManager(), $motype, true);
        /* now create a filter with above session */
        $ps = new PropertySet($vc, array(
                                      array('type' => 'ContainerView', "view")
                                      )
                );
        $os = new ObjectSet($vc, array(
                                    array('type' => 'ContainerView', 'value' => $view_sess)
                                    )
                );
        $vmfilter = new Filter($vc, $sc->getPropertyCollector(), $ps->propSet, $os->objectSet, true);
        $wfu     = WaitForUpdates($vc);
        $version = $wfu['version'];
        $filter  = $wfu['filterSet']['filter'];
        if ($filter == $vmfilter->filterID) {
                $objset    = $wfu['filterSet']['objectSet'];
                $changeset = $objset['changeSet'];
                $mo = $changeset['val']['ManagedObjectReference'];
                if (is_array($mo)) {
                        for ($i = 0 ; $i < count($mo); $i++) {
                                // echo "<br>$motype = $mo[$i]";
                                $mors[] = $mo[$i];
                        }
                } else {
                        //echo "<br>$motype = $mo";
                        $mors[] = $mo;
                }
        }
        return $mors;
}
function optionManager($vc)
{
        $viewmanager = 'OptionManager';           // ZZZ
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', 'OptionManager', $viewmanager, false, false, $vc->attrServerGuid);
        Red($vc, "CreateListView");
        $session = $conn->call("CreateListView", $soapmsg, $ns);
        return $session;


}
/* Works */
function createListView($vc, $viewmgr, $view, $motype, $mo)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;

        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', $viewmgr, $view, false, false, $vc->attrServerGuid);
        $soapmsg[]     = new soapval('obj', $motype, $mo, false, false, $vc->attrServerGuid);
        Red($vc, "CreateListView");
        $session = $conn->call("CreateListView", $soapmsg, $ns);
        Green($vc, $session);
        return $session;


}
function getList($vc, $sess)
{
        $ps = new PropertySet($vc, array(
                                      array(type => "Alarm", "info")
                                     )
                );
        $os = new ObjectSet($vc, array(
                                    array(type => 'ListView', value => $sess)
                                    )
                );
        $hafilter = new Filter($vc, $vc->sc['propertyCollector'], $ps->propSet, $os->objectSet);
        $wfu = WaitForUpdates($vc, $vc->sc['propertyCollector']);
        vcDebug($vc, $wfu);

        if (!strcmp($wfu['filterSet']['filter'], $vmfilter->filterID)) {
                $n = count($wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice']);
                echo "COUNT=$n";
                for ($i = 0; $i < $n; $i++) {
                        $vdevice[] = $wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice'];
                }
                $hafilter->Destroy($vc);
                return $vdevice;
        }
        $hafilter->Destroy($vc);
        return 0;
}
function createContainerView($vc, $container, $view, $type, $recursive = true)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg[] = new soapval('_this', 'ViewManager', $view, false, false, $vc->attrServerGuid);
        $soapmsg[] = new soapval('container', $container, 'group-d1', false, false, $vc->attrServerGuid);
        $soapmsg[] = new soapval('type', '', $type);
        $soapmsg[] = new soapval('recursive', '', $recursive);
        Red($vc, "CreateContainerView");
        $session = $conn->call("CreateContainerView", $soapmsg, $ns);
        Green($vc, $session);
        return $session;
}
function VirtualDevices($vc)
{
        $ps = new PropertySet(array(
                                      array( type => 'VirtualMachine',
                                             "config.hardware.device"
                                              )
                                      )
                );
                                              
        if ($vc->is_vCenter == true) {
                $os = new ObjectSet(array(
                                            array(type => 'VirtualMachine',
                                                  value => 'vm-39', // ZZZ
                                                  serverGuid => $vc->serverGuid)
                                            )
                        );
        } else {
                $os = new ObjectSet(array(
                                            array(type => 'VirtualMachine', value => 64) // ZZZ
                                            )
                        );
        }
        $vmfilter = new Filter($vc, $vc->sc['propertyCollector'], $ps->propSet, $os->objectSet);
        $wfu = WaitForUpdates($vc, $vc->sc['propertyCollector']);
        vcDebug($vc, $wfu);

        if (!strcmp($wfu['filterSet']['filter'], $vmfilter->filterID)) {
                $n = count($wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice']);
                for ($i = 0; $i < $n; $i++) {
                        $vdevice[] = $wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice'];
                }
                $vmfilter->Destroy($vc);
                return $vdevice;
        }
        $vmfilter->Destroy($vc);
        return 0;
}

/*
function getHosts($vc, $sess)
{
        $ps = new PropertySet($vc, array(
                                      array(type => "ManagedEntity", "name", "parent", "overallStatus", "tag", "effectiveRole", "disabledMethod"),
                                      array(type => "Folder", "childType", "childEntity.length"),
                                      array(type => "ComputeResource", "host.length"),
                                      array(type => "VirtualApp", "parentFolder", "summary"),
                                      array(type => "ResourcePool", "resourcePool.length", "vm.length"),
                                      array(type => "DistributedVirtualSwitch", "config.uuid", "capability", "config.uplinkPortgroup"),
                                      array(type => "DistributedVirtualPortgroup", "config.distributedVirtualSwitch", "config.key"), 
                                      array(type => "HostSystem", "summary.runtime.connectionState", "summary.runtime.powerState", "configIssue"),
                                      array(type => "VirtualMachine", "resourcePool", "runtime", "summary.config.template"),
                                      array(type => "ClusterComputeResource", "configuration.drsConfig", "configuration.dasConfig")
                                     )
                );
        $os = new ObjectSet($vc, array(
                                    array(type => 'InventoryView', value => $sess)
                                    )
                );
        $hafilter = new Filter($vc, $vc->sc['propertyCollector'], $ps->propSet, $os->objectSet);
        //$wfu = WaitForUpdates($vc, $vc->sc['propertyCollector']);
        vcDebug($vc, $wfu);

        if (!strcmp($wfu['filterSet']['filter'], $vmfilter->filterID)) {
                $n = count($wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice']);
                echo "COUNT=$n";
                for ($i = 0; $i < $n; $i++) {
                        $vdevice[] = $wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice'];
                }
                $hafilter->Destroy($vc);
                return $vdevice;
        }
        $hafilter->Destroy($vc);
        return 0;
}
*/
function Datacenter($vc)
{
        $ps = new PropertySet('ComputeResource',
                              array(
                                      "host.length"
//                                    "triggeredAlarmState",
//                                    "runtime.connectionState",
//                                    "runtime.powerState",
//                                    "summary.managementServerIp"
                                      ));
        $os = new ObjectSet(array(
                                    array(type => 'InventoryView', value => 'ha-host')
                                    )
                );
        $hafilter = new Filter($vc, $vc->sc['propertyCollector'], $ps->propSet, $os->objectSet);
        print $hafilter->filterID;
        $wfu = WaitForUpdates($vc, $vc->sc['propertyCollector']);
        vcDebug($vc, $wfu);

        if (!strcmp($wfu['filterSet']['filter'], $vmfilter->filterID)) {
                $n = count($wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice']);
                echo "COUNT=$n";
                for ($i = 0; $i < $n; $i++) {
                        $vdevice[] = $wfu['filterSet']['objectSet']['changeSet']['val']['VirtualDevice'];
                }
                $vmfilter->Destroy($vc);
                return $vdevice;
        }
        $vmfilter->Destroy($vc);
        return 0;
}

/* This most likely works, could not test */
function CreateInventoryView($vc)
{
        $viewmanager = 'ViewManager';           // ZZZ
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', 'ViewManager', $viewmanager, false, false, $vc->attrServerGuid);
        Red($vc, "CreateInventoryView");
        $session = $conn->call("CreateInventoryView", $soapmsg, $ns);
        return $session;
}

function OpenInventoryViewFolder($vc, $sess, $folders)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        
        $soapmsg[] = new soapval('_this', 'InventoryView', $sess, false, false, $vc->attrServerGuid);
        foreach ($folders as $folder) {
                $soapmsg[] = new soapval('entity', $folder['type'], $folder['folder'],
                                         false, false, $vc->attrServerGuid);
        }
        Red($vc, "OpenInventoryFolder");
        $result = $conn->call("OpenInventoryViewFolder", $soapmsg, $ns);
        $wfu = WaitForUpdates($vc, $vc->sc[propertyCollector]);
        vcDebug($vc, $result);
        return $result;
}
/* Works */
function FindByInventoryPath($vc, $s_mor, $item)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', 'SearchIndex', 'SearchIndex');
        $soapmsg['inventoryPath'] = $item;
        $result = $conn->call("FindByInventoryPath", $soapmsg, $ns);
        vcDebug($vc, $result);
        return $result;    
}
function FindChild($vc, $s_mor, $child)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', 'SearchIndex', 'SearchIndex');
        $soapmsg['entity'] = new soapval('entity', 'Datacenter', 'datacenter-7');
        $soapmsg['name'] = $child;
        $result = $conn->call("FindChild", $soapmsg, $ns);
        vcDebug($vc, $result);
        return $result;    
}
function FindByIp($vc, $s_mor, $ip, $vmsearch = false)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', 'SearchIndex', 'SearchIndex');
        $soapmsg['ip'] = $ip;
        $soapmsg['vmSearch'] = $vmsearch;
        $result = $conn->call("FindByInventoryPath", $soapmsg, $ns);
        vcDebug($vc, $result);
        return $result;    
}
function HostSystem($vc)
{
        $conn = $vc->conn;
        $ns   = $vc->ns;
        unset($soapmsg);
        $soapmsg['data'] = new soapval('_this', 'HostSystem', 'HostSystem');
        $result = $conn->call("AddHost_Task", $soapmsg, $ns);
        vcDebug($vc, $result);
        return $result;
}

function RootFolder($si)
{
        return $sc['rootFolder'];
}

function findHostMOR($vc, $hostname)
{
        $host_mors    = getMORS($vc, 'HostSystem');

        foreach ($host_mors as $host_mor) {
                $host = new Host($vc, $host_mor);
                $ret  = $host->retrieveProperties("config");
                $fqdn = $host->getHostFQDN();
                if (!strcmp($fqdn, $hostname)) {
                        return $host_mor;
                }
        }
        return 0;
}

?>
