<?php
require_once("switch/raslog.php");
require_once("switch/logconfig.php");
require_once("switch/logging.php");

define("DISC_MSG_TYPE_CREATE", 0);
define("DISC_MSG_TYPE_UPDATE", 1);
define("DISC_MSG_TYPE_DELETE", 2);
define("DISC_MSG_TYPE_PERSIST", 3);
define("DISC_MSG_TYPE_REMOVE_PERSIST", 4);

define("DC_DB_PREV", "/tmp/dc.db.prev");
define("DC_DB", "/tmp/dc.db");
define("DC_DB_EMPTY", "/fabos/webtools/htdocs/ws/config/dc.db");

define("PER_DC_DB", "/var/tmp/dc.db");
define("PER_DC_DB_NEW", "/var/tmp/dc.db.new");
define("MNT_PER_DC_DB", "/mnt/var/tmp/dc.db");
define("MNT_PER_DC_DB_NEW", "/mnt/var/tmp/dc.db.new");


$vcenter  = $_SERVER[argv][1];
$cmdcode  = $_SERVER[argv][2];
$msgType  = $_SERVER[argv][3];


if ($msgType == DISC_MSG_TYPE_PERSIST) {
 if(file_exists(DC_DB_PREV)){
   copy(DC_DB_PREV, PER_DC_DB);
   copy(DC_DB_PREV, MNT_PER_DC_DB);
  }
  else{
     copy(DC_DB_EMPTY, PER_DC_DB);
     copy(DC_DB_EMPTY, MNT_PER_DC_DB); 

  }
 copy(DC_DB, PER_DC_DB_NEW);
 copy(DC_DB, MNT_PER_DC_DB_NEW);
 raslogv(VCLOG_INFO, "Persistence of DB completed.");
} else if($msgType == DISC_MSG_TYPE_REMOVE_PERSIST){
   unlink(PER_DC_DB);
   unlink(PER_DC_DB_NEW);
   unlink(MNT_PER_DC_DB);
   unlink(MNT_PER_DC_DB_NEW);
} 
exit(0);
?>
