<?php

require_once("nusoap/nusoap.php");
require_once("config/config.php");
require_once("VC/vCenter.php");
require_once("VC/vAPI.php");
require_once("VC/pc.php");
require_once("VC/si.php");
require_once("VC/sql.php");
require_once("VC/utils.php");
require_once("VC/dvswitch.php");
require_once("switch/raslog.php");
require_once("switch/portprofile.php");
require_once("switch/interface.php");
require_once("switch/switchport.php");
require_once("switch/logconfig.php");
require_once("switch/logging.php");

define("PER_DC_DB", "/var/tmp/dc.db");
define("PER_DC_DB_NEW", "/var/tmp/dc.db.new");
define("MNT_PER_DC_DB", "/mnt/var/tmp/dc.db");
define("MNT_PER_DC_DB_NEW", "/mnt/var/tmp/dc.db.new");

function getPPS()
{
   $ns = appm__ns;
   $sock = maapi_connect($ns);
   $path   = "/appm:port-profile";
   $pps = maapi_get_list_keys($sock, $path);
   maapi_close($sock);
    return $pps;
}
$auto_profiles_present = false;
$log = Logging::getInstance(); 
raslogv(VCLOG_INFO, "START: Clearing the old portprofiles for the first time");
//remove the auto- port profiles
$pps = getPPS();
$pp_sock = maapi_connect1();
foreach ($pps as $pp_nn) {
//    $pp_nn = trimSpaces($pp_nn);
    if (!strncasecmp($pp_nn, "auto-", 5)) {
raslogv(VCLOG_DEBUG, "DELETE: profile $pp_nn");
        $pp = new portprofile($pp_nn);
        $pp->delete($pp_sock);
        $auto_profiles_present = true;
        unset($pp);
    }
}
maapi_close($pp_sock);

if($auto_profiles_present  == false){
   unlink(PER_DC_DB);
   unlink(PER_DC_DB_NEW);
   unlink(MNT_PER_DC_DB);
   unlink(MNT_PER_DC_DB_NEW);	
}

function getInterfaces()
{
   $sock = maapi_connect($ns);
   $path   = "/logical_switch:interface/tengigabitethernet";
   $ifs = maapi_get_list_keys($sock, $path);
   maapi_close($sock);
   return $ifs;
}

//remove pp mode from interfaces
/*$ifs = getInterfaces();
foreach ($ifs as $if_nn) {
    print $if_nn . "\n";
    $is_maapi_pp_port = 0;
    $sock = maapi_connect($ns);
    $path   = "/logical_switch:interface/tengigabitethernet{".$if_nn."}/is-maapi-pp-port";
    //$path   = "/logical_switch:interface/tengigabitethernet{".$if_nn."}/port-profile-port";
    echo "$path\n";
    $is_maapi_pp_port = maapi_get_elem2($sock, $path);
    echo "1:$is_maapi_pp_port\n";
    maapi_close($sock);
    if ($is_maapi_pp_port != -1) {
        print "pp-mode is set\n";
        $sp = new switchport($if_nn);
        raslogv(RASLOG_INFO, "disableProfileMode ---");
        $sp->disableProfileMode();
    }
}
*/

$log->lclose();
?>
