<?php
    require_once("VC/sql.php");
    require_once("VC/dvswitch.php");
    require_once("VC/vCenter.php");
    require_once("VC/si.php");
    require_once("VC/utils.php");
    require_once("nusoap/nusoap.php");
    require_once("VC/pc.php");

    define("POWERED_OFF", 0);
    define("POWERED_ON",  1);
    define("INVALID_CONNECTION",  2);
    define("INVALID_CREDENTIALS", 3);
    define("INVALID_VERSION",     4);
    define("NO_SERVICE",          5);
    define("SUSPENDED", 6);
    define("INVALID_VM", 7);


    $url    = $_SERVER[argv][1];
    $user   = $_SERVER[argv][2];
    $pass   = $_SERVER[argv][3];
	//$timeout= $_SERVER[argv][4];
	$vm_mor = $_SERVER[argv][4];

    // Connect to vCenter
    unset($vc);
    $ns = '';
    if (($vc  = new vCenter($url, $ns, $user, $pass)) < 0) {
    }

    if (($ret = $vc->vConnect()) < 0) {
    //if (($ret = $vc->vConnect($timeout)) < 0) {
        exit(INVALID_CONNECTION);
    }

    $ret = $vc->initServices();
    if ($ret == -1) {
        exit(NO_SERVICE);
    }
    $version = $vc->getVersion();
	if (!starts_with($version,"4") && !starts_with($version,"5")) {
        exit(INVALID_VERSION);
    }
    if (($ret = $vc->login()) != 1) {
        exit(INVALID_CREDENTIALS);
    }

    $vm = new vm($vc, $vm_mor);
    if ($vm->retrieveProperties() == 0) {
        echo "invalid vm\n"; 
        exit(INVALID_VM);
    }

        
    $power = $vm->getVmPowerStatus();      
    echo "$power\n";
    if ($power == "poweredOn")
        exit(POWERED_ON);

    if($power == "poweredOff")
        exit(POWERED_OFF);

    if($power == "suspended")
        exit(SUSPENDED);

?>
