<?php

require_once("VC/sql.php");
require_once("VC/utils.php");
require_once("VC/dvswitch.php");
require_once("switch/raslog.php");
require_once("switch/logging.php");

$dbnew = "sqlite:/tmp/dc.db.new";
$dbold = "sqlite:/tmp/dc.db";

define("SUCCESS",             0);
define("INVALID_RESPONSE",    1);

$invalidResponse = 0;

raslogv(RASLOG_INFO, "START: checking port profiles");

    /* Cheking portgroups table*/

    $table = "portgroups";
    $q1      = "SELECT COUNT(*) FROM $table";
    $dbh1 = new DB($dbold);
    $res1 = $dbh1->conn->query($q1);
    $count1 = $res1->fetchColumn();

    $dbh2 = new DB($dbnew);
    $res2 = $dbh2->conn->query($q1);
    $count2 = $res2->fetchColumn();

    if ( ($count1 != 1) && ($count2 == 1) )
    {
        print("Invalid response from vCenter: $count2 PGs.\n");
        //return
        exit(INVALID_RESPONSE);
    }
    else
    {
        print("Valid response from vCenter: $count2 PGs.\n");
        //no return
        //exit(SUCCESS);
    }

    /* Cheking dvportgroups table */

    $table = "dvportgroups";
    $q1      = "SELECT COUNT(*) FROM $table";
    $dbh1 = new DB($dbold);
    $res1 = $dbh1->conn->query($q1);
    $count1 = $res1->fetchColumn();

    $dbh2 = new DB($dbnew);
    $res2 = $dbh2->conn->query($q1);
    $count2 = $res2->fetchColumn();

    if ( ($count1 != 1) && ($count2 == 1 ) )
    {
        print("Invalid response from vCenter: $count2 DvPgs.\n");
        //return
        exit(INVALID_RESPONSE);
    }
    else
    {
        print("Valid response from vCenter: $count2 DvPgs.\n");
        //no return
        //exit(SUCCESS);
    }

	/* checking vms table */ 

	$table = "vms";
    $q1      = "SELECT COUNT(*) FROM $table";

    $dbh1 = new DB($dbold);
    $res1 = $dbh1->conn->query($q1);
    $count1 = $res1->fetchColumn();

	$dbh2 = new DB($dbnew);
	$res2 = $dbh2->conn->query($q1);
	$count2 = $res2->fetchColumn();

    if ( ($count1 != 1) && ($count2 == 1 ))
    {
        print("Invalid response from vCenter: $count2 vms.\n");
        //return
        exit(INVALID_RESPONSE);
    }
    else
    {
        print("Valid response from vCenter: $count2 vms.\n");
        exit(SUCCESS);
    }
	
?>
