<?php
require_once("VC/sql.php");
require_once("switch/raslog.php");
require_once("switch/logconfig.php");
require_once("switch/logging.php");

define("DISC_CMD_DISCOVER_VCENTER",1);
define("DISC_CMD_DISCOVER_ALL_VCENTER", 2);
define("DISC_CMD_NODE_ADD", 3);
define("DISC_CMD_SYNC_PERSISTED_WITH_RUNNING", 5);


$vcenter  = $_SERVER[argv][1];
$cmdcode  = $_SERVER[argv][2];

$db1 = "sqlite:/tmp/dc.db";
$db2 = "sqlite:/tmp/dc.db.new";

$dbh1 = new DB($db1);
$dbh2 = new DB($db2);



raslogv(VCLOG_INFO, "START: copy started.");
if (($cmdcode == DISC_CMD_NODE_ADD) || ($cmdcode == DISC_CMD_SYNC_PERSISTED_WITH_RUNNING)) {
    raslogv(VCLOG_INFO, "cmdcode $cmdcode");
    $table = "vmnics";
    $q1    = "UPDATE $table SET iface = '', createTS = '' WHERE id!='Title'";
    raslogv(VCLOG_INFO, "$q1");
    $stmt1 = $dbh2->conn->prepare($q1);
    $stmt1->execute();
    copy("/tmp/dc.db.new", "/tmp/dc.db");
    exit(0);
}


copy("/tmp/dc.db", "/tmp/dc.db.prev");
raslogv(VCLOG_INFO, "copy dc.db to dc.db.prev completed.");

raslogv(VCLOG_INFO, "Discover cmdcode $cmdcode");
$table = "vnics";
$q1    = "SELECT id,dvpg_nn,port_prof FROM $table";
$stmt1 = $dbh1->conn->prepare($q1);
$stmt1->execute();
while ($row1 = $stmt1->fetch(PDO::FETCH_ASSOC)) {

      $dvpg_nn   = sqlite_escape_string($row1['dvpg_nn']);
      $id      = $row1['id'];
      $port_prof = $row1['port_prof'];
      // update only if empty 
      $vnic_rows = $dbh2->getTableObjs("vnics","id='$id'");
      $pp_nn    = $vnic_rows[0]['port_prof'];
      //          $q     = "SELECT * FROM '$table' WHERE id= '$id'";
               // echo $q;

                //$stmt  = $dbh2->conn->query($q);
                //$rows = $stmt->fetchAll(PDO::FETCH_BOTH);
      //$pp_nn    = $rows[0]['port_prof'];
      raslogv(VCLOG_DEBUG, "Returned $id $pp_nn.");
      if(!empty($pp_nn)) continue;
        $q2        = "UPDATE $table SET port_prof = '$port_prof' WHERE id = '$id'";
        raslogv(VCLOG_DEBUG, "$q2");
        $stmt2     = $dbh2->conn->prepare($q2);
        $stmt2->execute();
      //}      
}

$table = "vmnics";
$q1    = "SELECT id,iface,createTs FROM $table";
$stmt1 = $dbh1->conn->prepare($q1);
$stmt1->execute();
while ($row1 = $stmt1->fetch(PDO::FETCH_ASSOC)) {

      $id      = $row1['id'];
      $iface   = $row1['iface'];
      $createTS   = $row1['createTS'];
      $q2      = "UPDATE $table SET iface = '$iface', createTS = '$createTS' WHERE id = '$id'";
      raslogv(VCLOG_DEBUG, "$q2");
      $stmt2   = $dbh2->conn->prepare($q2);
      $stmt2->execute();
}

copy("/tmp/dc.db.new", "/tmp/dc.db");
  raslogv(VCLOG_INFO, "END: copy completed.");
exit(0);
?>
