<?php

require_once("nusoap/nusoap.php");
require_once("config/config.php");
require_once("VC/vCenter.php");
require_once("VC/vAPI.php");
require_once("VC/pc.php");
require_once("VC/si.php");
require_once("VC/sql.php");
require_once("VC/utils.php");
require_once("VC/dvswitch.php");
require_once("switch/raslog.php");
require_once("switch/logging.php");
require_once("switch/portprofile.php");
require_once("switch/interface.php");
require_once("switch/cdpconfig.php");
require_once("delta.php");
require_once("switch/logconfig.php");

define("DISC_MSG_TYPE_CREATE", 0);
define("DISC_MSG_TYPE_UPDATE", 1);
define("DISC_MSG_TYPE_DELETE", 2);

$vcenter  = $_SERVER[argv][1];
$cmdcode  = $_SERVER[argv][2];
$msgType  = $_SERVER[argv][3];

$dbnew = "sqlite:/tmp/dc.db.new";
$dbold = "sqlite:/tmp/dc.db";


$log = Logging::getInstance(); 
$del="false";
if ($msgType == DISC_MSG_TYPE_DELETE) {
    $cdp = new cdp();
    $cdp->disableCdp();
    $del="true";
} else {
    $cdp = new cdp();
    $cdp->enableCdp();
    $del="false";
}

raslogv(RASLOG_INFO, "START: Updating the port profiles");
$sw = new StopWatch();
$csw = new StopWatch();


$table = "dvportgroups";
$ret = diffTable($table, $dbnew, $dbold, $pp, $del);

   $time = $sw->elapsedTime();
   raslogv(VCLOG_INFO, "diffTable $table TIME $time seconds");
   $sw->resetAndStart();

$table = "portgroups";
$ret = diffTable($table, $dbnew, $dbold, $pp, $del);

   $time = $sw->elapsedTime();
   raslogv(VCLOG_INFO, "diffTable $table TIME $time seconds");

if ($del != "true")    {
raslogv(RASLOG_INFO, "START: MAC Associations to port profiles");
   $sw->resetAndStart();
$table = "vnics";
    $ret = diffTable($table, $dbnew, $dbold, $pp, $del);
   $time = $sw->elapsedTime();
   raslogv(VCLOG_INFO, "diffTable $table TIME $time seconds");
}

raslogv(RASLOG_INFO, "END: Updating the port profiles");
   $time = $csw->elapsedTime();
   raslogv(VCLOG_CRITICAL, "VC-PP-Create Completed in $time seconds");

$log->lclose();


?>

