<?php

require_once("logconfig.php");
require_once("logging.php");

define("RASLOG_INFO",     1);
define("RASLOG_WARNING",  2);
define("RASLOG_ERROR",    3);
define("RASLOG_CRITICAL", 4);

function raslogv($type, $msg)
{
$log = Logging::getInstance(); 
        $typeStr = "INFO: ";
        switch($type) {
            case 1:
                $typeStr = "INFO: "; break;
            case 12:
                $typeStr = "INFO: "; break;
            case 2:
                $typeStr = "WARNING: "; break;
            case 11:
                $typeStr = "WARNING: "; break;
            case 3:
                $typeStr = "ERROR: "; break;
            case 10:
                $typeStr = "CRITICAL: "; break;
            case 4:
                $typeStr = "CRITICAL: "; break;
            case 13:
                $typeStr = "DEBUG: "; break;
            case 14:
                $typeStr = "TRACE: "; break;
        }

    if ($type == RASLOG_INFO ||
        $type == RASLOG_WARNING ||
        $type == RASLOG_ERROR ||
        $type == RASLOG_CRITICAL) {
            raslog("", "", 9999, $type, $msg);
            $log->lwrite($typeStr.$msg);
    }else {
        // this is a log only situation
        if ($type <= LOG_LEVEL) {
            if (is_array($msg)) {
                $log->lwrite($typeStr.print_r($msg, true));
            }else {
                $log->lwrite($typeStr.$msg);
            }
        }
    }

}

?>
